# Configuring Uploader's "Recall" functionality

## Overview

Once the fields and data are initially mapped, subsequent upload logic can be recalled based on the optional [Parameterized Fields](/developer-docs/parameterized-fields.md), "userID" and "userGroup". Which, unlike other parameterized fields, are defined outside the schema.

Here's an example of using the `userID` parameterized field to populate a field called `user_id` for every row by pulling the property `curUserID` from the browser.&#x20;

There are two applications of Parameterized Fields in this example:

1. The `curUserID` becomes the value of the `userID` parameter, which is used to control recall.
2. Also, the `userID` parameter is being used to populate the field `user_id` within the uploaded data itself - this is optional.

```javascript
<script>
  Osmos.configure({
    userID: window.curUserID,
    schema: {
      fields: [
        {
          name: "user_id",
          fieldType: 'userID'
        },
        ...
      ]
    },
    ...
  });
</script>
```

### Hierarchy of Recall

1. If you are passing a [userID](/developer-docs/parameterized-fields.md), it will recall by userID first.
2. If you are passing a [userGroup](/developer-docs/parameterized-fields.md), it will be recalled next by the userGroup.
3. If you are user neither userID nor userGroup, it will recall by uploader token. This means recall will be performed on the uploader level.&#x20;

{% hint style="info" %}
While the Recall and the Auto-Mapping behavior is usually useful to speed up mapping and ease the upload process, there are some scenarios where it is undesired.  Here are the settings to [disable these features](/developer-docs/optional-uploader-settings.md).&#x20;
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.osmos.io/developer-docs/configuring-uploaders-recall-functionality.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
